/*
 * Copyright (c) 1981, 1993, 1994
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static char sccsid[] = "@(#)addch.c	8.2 (Berkeley) 5/4/94";
#endif	/* not lint */

#include "curses.h"

/*
 * waddch --
 *	Add the character to the current position in the given window.
 *
 */
int
waddch(win, ch)
	WINDOW *win;
	int ch;
{
	__LDATA buf;

#if 0
	if (ch == 0x1B) win->shift = _WSH_ESC;
	else switch (win->shift) {
	case _WSH_ESC:
		if (ch == '$') win->shift = _WSH_WB0;
		else if (ch == '(') win->shift = _WSH_SB0;
		else win->shift = _WSH_NO;
		break;
	case _WSH_WB0:
		if (ch == 'B') win->shift = _WSH_WB1;
		else win->shift = _WSH_NO;
		break;
	case _WSH_SB0:
		if (ch == 'B') win->shift = _WSH_SB1;
		else win->shift = _WSH_NO;
		break;
	default:
		if (ch & 0x80) {
			if (win->code == _CODE_SB)
				win->code = _CODE_WB1;
			else if (win->code == _CODE_WB1)
				win->code = _CODE_WB2;
		} else if (win->shift == _WSH_WB1) {
			win->code = _CODE_WB1;
			win->shift = _WSH_WB2;
			ch |= 0x80;
		} else if (win->shift == _WSH_WB2) {
			win->code = _CODE_WB2;
			win->shift = _WSH_WB1;
			ch |= 0x80;
		} else win->code = _CODE_SB;
		buf.attr = win->code;
/*
if (buf.attr) fprintf(stderr, "[%02X:%02X]\n", ch, buf.attr);
*/
		buf.ch = ch;
		return (__waddch(win, &buf));
	}
	return(1);
#else
	buf.ch = ch;
	buf.attr = 0;
	return (__waddch(win, &buf));
#endif
}

int
__waddch(win, dp)
	WINDOW *win;
	__LDATA *dp;
{
	char buf[2];

	buf[0] = dp->ch;
	return (__waddbytes(win, buf, 1, dp->attr & __STANDOUT));
}
